/*******************************************************************************
 * Copyright (c) 2002, 2003 Eteration Bilisim A.S., Naci Dai and others.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the GNU Lesser General Public License (LGPL)
 * which accompanies this distribution, and is available at
 *  http://www.gnu.org/licenses/lgpl.html
 * 
 * Contributors:
 *     Eteration Bilisim A.S. - initial API and implementation
 *     Naci M. Dai
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution, if
 *    any, must include the following acknowlegement:
 *       "This product includes software developed by the
 *        Eteration Bilisim A.S and Naci Dai (http://www.eteration.com/)."
 *    Alternately, this acknowlegement may appear in the software itself,
 *    if and wherever such third-party acknowlegements normally appear.
 *
 * 4. The names "Lomboz", "ObjectLearn" and "Eteration" must not be used to endorse or promote products derived
 *    from this software without prior written permission. For written
 *    permission, please contact info@eteration.com.
 *
 * 5. Products derived from this software may not be called "Lomboz"
 *    nor may "Lomboz" appear in their names without prior written
 *    permission of the Eteration Bilisim A.S.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Eteration Bilisim A.S.  For more
 * information on eteration, please see
 * <http://www.eteration.com/>.
 ***************************************************************************/
/*
 * Created on Mar 16, 2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package org.objectweb.eclipsespeedo.drivers.xml;

/**
 * @author Naci Dai
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class DriverDefinitionProperty {
	public static final int STRING = 0;
	public static final int FILE = 1;
	public static final int DIRECTORY = 2;
	public static final int BOOLEAN = 3;
	public static final int COMBO = 4;
	public static final int EFOLDER = 5;
	public static final int PCLASSPATH = 6;
			
	private String id;
	private String label;
	private int type;
	private String defaultValue;
	private boolean modifiable = true;
	private Object tempValue;
	private String desc = "";

	/**
	 * @return String
	 */
	public String getDefaultValue() {
		return defaultValue;
	}

	/**
	 * @return String
	 */
	public String getId() {
		return id;
	}

	/**
	 * @return String
	 */
	public String getLabel() {
		return label;
	}

	/**
	 * @return int
	 */
	public int getType() {
		return type;
	}

	/**
	 * Sets the defaultValue.
	 * @param defaultValue The defaultValue to set
	 */
	public void setDefaultValue(String defaultValue) {
		this.defaultValue = defaultValue;
	}

	/**
	 * Sets the id.
	 * @param id The id to set
	 */
	public void setId(String id) {
		this.id = id;
	}

	/**
	 * Sets the label.
	 * @param label The label to set
	 */
	public void setLabel(String label) {
		this.label = label;
	}

	/**
	 * Sets the type.
	 * @param type The type to set
	 */
	public void setType(int type) {
		this.type = type;
	}
	public void setTypeFromStr(String str) {
		if ("string".equals(str))
			this.type = STRING;
		else if ("directory".equals(str))
			this.type = DIRECTORY;
		else if ("file".equals(str))
			this.type = FILE;
		else if ("boolean".equals(str))
			this.type = BOOLEAN;
		else if ("efolder".equals(str))
			this.type = EFOLDER;
		else if ("combo".equals(str))
			this.type = COMBO;
		else if ("pclasspath".equals(str))
			this.type = PCLASSPATH;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return "\n<property id=\""
			+ this.getId()
			+ "\"\n\tlabel=\""
			+ this.getLabel()
			+ "\"\n\ttype=\""
			+ (type == DIRECTORY
				? "directory"
				: (type == STRING
					? "string"
					: (type == FILE
						? "file"
						: (type == BOOLEAN 
							? "boolean" 
							: (type == COMBO
								? "combo"
								: (type == EFOLDER
									? "efolder"
									: (type == PCLASSPATH
										? "pclasspath":"undefined")))))))
			+ "\"\n\tmodifiable=\""
			+ (this.isModifiable()?"true":"false")
			+ "\"\n\tdescription=\""
			+ this.getDesc()
			+ "\"\n\tdefault=\""
			+ this.getDefaultValue()
			+ "\" />";
	}

	/**
	 * @return
	 */
	public boolean isModifiable() {
		return modifiable;
	}

	/**
	 * @param b
	 */
	public void setModifiable(String b) {
		if (b == null) return;
		if (b.equals("false")) modifiable = false;
	}

	/**
	 * @return
	 */
	public Object getTempValue() {
		return tempValue;
	}

	/**
	 * @param object
	 */
	public void setTempValue(Object object) {
		tempValue = object;
	}

	/**
	 * @return
	 */
	public String getDesc() {
		return desc;
	}

	/**
	 * @param string
	 */
	public void setDesc(String string) {
		if (string!=null) desc = string;
	}

}
