/*******************************************************************************
 * EclipseJDO: Plugin for JDO drivers within Eclipse platform
 * Copyright (c) 2002, 2003 Versant France http://www.versant.fr
 * 
 * This program is free software; you can redistribute it and/or modify  it 
 * under the terms of the GNU General Public License as published by  the Free 
 * Software Foundation; either version 2 of the License, or  (at your option) any 
 * later version. 

 * This program is distributed in the hope that it will be useful,  but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE.  See the  GNU General Public License for more details. 

 * You should have received a copy of the GNU General Public License along with 
 * this program; if not, write to the Free Software  Foundation, Inc., 59 Temple 
 * Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contributors:
 * 	 Versant France
 * 		Yves Yang (yang@versant.fr)
 * 
 *******************************************************************************/

package org.objectweb.eclipsespeedo.metadata;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->A representation of the model object '<em><b>JDO Array</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link EclipseSpeedo.metadata.JDOArray#getEmbeddedElement <em>Embedded Element</em>}</li>
 *   <li>{@link EclipseSpeedo.metadata.JDOArray#getExtensions <em>Extensions</em>}</li>
 * </ul>
 * </p>
 *
 * @see EclipseSpeedo.metadata.MetadataPackage#getJDOArray()
 * @model 
 * @generated
 */
public interface JDOArray extends JDOObject{
	/**
	 * Returns the value of the '<em><b>Embedded Element</b></em>' attribute.
	 * The literals are from the enumeration {@link EclipseSpeedo.metadata.JDOBoolean}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Embedded Element</em>' attribute isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Embedded Element</em>' attribute.
	 * @see EclipseSpeedo.metadata.JDOBoolean
	 * @see #setEmbeddedElement(JDOBoolean)
	 * @see EclipseSpeedo.metadata.MetadataPackage#getJDOArray_EmbeddedElement()
	 * @model 
	 * @generated
	 */
	JDOBoolean getEmbeddedElement();

	/**
	 * Sets the value of the '{@link EclipseSpeedo.metadata.JDOArray#getEmbeddedElement <em>Embedded Element</em>}' attribute.
	 * <!-- begin-user-doc --><!-- end-user-doc -->
	 * @param value the new value of the '<em>Embedded Element</em>' attribute.
	 * @see EclipseSpeedo.metadata.JDOBoolean
	 * @see #getEmbeddedElement()
	 * @generated
	 */
	void setEmbeddedElement(JDOBoolean value);

	/**
	 * Returns the value of the '<em><b>Extensions</b></em>' containment reference list.
	 * The list contents are of type {@link EclipseSpeedo.metadata.JDOExtension}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Extensions</em>' containment reference
	 * list isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Extensions</em>' containment reference list.
	 * @see EclipseSpeedo.metadata.MetadataPackage#getJDOArray_Extensions()
	 * @model type="EclipseSpeedo.metadata.JDOExtension" containment="true"
	 * @generated
	 */
	EList getExtensions();

} // JDOArray
