/*******************************************************************************
 * EclipseJDO: Plugin for JDO drivers within Eclipse platform
 * Copyright (c) 2002, 2003 Versant France http://www.versant.fr
 * 
 * This program is free software; you can redistribute it and/or modify  it 
 * under the terms of the GNU General Public License as published by  the Free 
 * Software Foundation; either version 2 of the License, or  (at your option) any 
 * later version. 

 * This program is distributed in the hope that it will be useful,  but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE.  See the  GNU General Public License for more details. 

 * You should have received a copy of the GNU General Public License along with 
 * this program; if not, write to the Free Software  Foundation, Inc., 59 Temple 
 * Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contributors:
 * 	 Versant France
 * 		Yves Yang (yang@versant.fr)
 * 
 *******************************************************************************/

package org.objectweb.eclipsespeedo.metadata;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->A representation of the model object '<em><b>JDO Extension</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link EclipseSpeedo.metadata.JDOExtension#getVendorName <em>Vendor Name</em>}</li>
 *   <li>{@link EclipseSpeedo.metadata.JDOExtension#getKey <em>Key</em>}</li>
 *   <li>{@link EclipseSpeedo.metadata.JDOExtension#getValue <em>Value</em>}</li>
 *   <li>{@link EclipseSpeedo.metadata.JDOExtension#getExtensions <em>Extensions</em>}</li>
 * </ul>
 * </p>
 *
 * @see EclipseSpeedo.metadata.MetadataPackage#getJDOExtension()
 * @model 
 * @generated
 */
public interface JDOExtension extends JDOObject{
	/**
	 * Returns the value of the '<em><b>Vendor Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Vendor Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Vendor Name</em>' attribute.
	 * @see #setVendorName(String)
	 * @see EclipseSpeedo.metadata.MetadataPackage#getJDOExtension_VendorName()
	 * @model 
	 * @generated
	 */
	String getVendorName();

	/**
	 * Sets the value of the '{@link EclipseSpeedo.metadata.JDOExtension#getVendorName <em>Vendor Name</em>}' attribute.
	 * <!-- begin-user-doc --><!-- end-user-doc -->
	 * @param value the new value of the '<em>Vendor Name</em>' attribute.
	 * @see #getVendorName()
	 * @generated
	 */
	void setVendorName(String value);

	/**
	 * Returns the value of the '<em><b>Key</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Key</em>' attribute isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Key</em>' attribute.
	 * @see #setKey(String)
	 * @see EclipseSpeedo.metadata.MetadataPackage#getJDOExtension_Key()
	 * @model 
	 * @generated
	 */
	String getKey();

	/**
	 * Sets the value of the '{@link EclipseSpeedo.metadata.JDOExtension#getKey <em>Key</em>}' attribute.
	 * <!-- begin-user-doc --><!-- end-user-doc -->
	 * @param value the new value of the '<em>Key</em>' attribute.
	 * @see #getKey()
	 * @generated
	 */
	void setKey(String value);

	/**
	 * Returns the value of the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Value</em>' attribute isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Value</em>' attribute.
	 * @see #setValue(String)
	 * @see EclipseSpeedo.metadata.MetadataPackage#getJDOExtension_Value()
	 * @model 
	 * @generated
	 */
	String getValue();

	/**
	 * Sets the value of the '{@link EclipseSpeedo.metadata.JDOExtension#getValue <em>Value</em>}' attribute.
	 * <!-- begin-user-doc --><!-- end-user-doc -->
	 * @param value the new value of the '<em>Value</em>' attribute.
	 * @see #getValue()
	 * @generated
	 */
	void setValue(String value);

	/**
	 * Returns the value of the '<em><b>Extensions</b></em>' containment reference list.
	 * The list contents are of type {@link EclipseSpeedo.metadata.JDOExtension}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Extensions</em>' containment reference
	 * list isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Extensions</em>' containment reference list.
	 * @see EclipseSpeedo.metadata.MetadataPackage#getJDOExtension_Extensions()
	 * @model type="EclipseSpeedo.metadata.JDOExtension" containment="true"
	 * @generated
	 */
	EList getExtensions();

} // JDOExtension
