/*******************************************************************************
 * EclipseJDO: Plugin for JDO drivers within Eclipse platform
 * Copyright (c) 2002, 2003 Versant France http://www.versant.fr
 * 
 * This program is free software; you can redistribute it and/or modify  it 
 * under the terms of the GNU General Public License as published by  the Free 
 * Software Foundation; either version 2 of the License, or  (at your option) any 
 * later version. 

 * This program is distributed in the hope that it will be useful,  but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE.  See the  GNU General Public License for more details. 

 * You should have received a copy of the GNU General Public License along with 
 * this program; if not, write to the Free Software  Foundation, Inc., 59 Temple 
 * Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contributors:
 * 	 Versant France
 * 		Yves Yang (yang@versant.fr)
 * 
 *******************************************************************************/

package org.objectweb.eclipsespeedo.metadata;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->A representation of the model object '<em><b>JDO Map</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link EclipseSpeedo.metadata.JDOMap#getKeyType <em>Key Type</em>}</li>
 *   <li>{@link EclipseSpeedo.metadata.JDOMap#getEmbeddedKey <em>Embedded Key</em>}</li>
 *   <li>{@link EclipseSpeedo.metadata.JDOMap#getValueType <em>Value Type</em>}</li>
 *   <li>{@link EclipseSpeedo.metadata.JDOMap#getEmbeddedValue <em>Embedded Value</em>}</li>
 *   <li>{@link EclipseSpeedo.metadata.JDOMap#getExtensions <em>Extensions</em>}</li>
 * </ul>
 * </p>
 *
 * @see EclipseSpeedo.metadata.MetadataPackage#getJDOMap()
 * @model 
 * @generated
 */
public interface JDOMap extends JDOObject{
	/**
	 * Returns the value of the '<em><b>Key Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Key Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Key Type</em>' attribute.
	 * @see #setKeyType(String)
	 * @see EclipseSpeedo.metadata.MetadataPackage#getJDOMap_KeyType()
	 * @model 
	 * @generated
	 */
	String getKeyType();

	/**
	 * Sets the value of the '{@link EclipseSpeedo.metadata.JDOMap#getKeyType <em>Key Type</em>}' attribute.
	 * <!-- begin-user-doc --><!-- end-user-doc -->
	 * @param value the new value of the '<em>Key Type</em>' attribute.
	 * @see #getKeyType()
	 * @generated
	 */
	void setKeyType(String value);

	/**
	 * Returns the value of the '<em><b>Embedded Key</b></em>' attribute.
	 * The literals are from the enumeration {@link EclipseSpeedo.metadata.JDOBoolean}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Embedded Key</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Embedded Key</em>' attribute.
	 * @see EclipseSpeedo.metadata.JDOBoolean
	 * @see #setEmbeddedKey(JDOBoolean)
	 * @see EclipseSpeedo.metadata.MetadataPackage#getJDOMap_EmbeddedKey()
	 * @model 
	 * @generated
	 */
	JDOBoolean getEmbeddedKey();

	/**
	 * Sets the value of the '{@link EclipseSpeedo.metadata.JDOMap#getEmbeddedKey <em>Embedded Key</em>}' attribute.
	 * <!-- begin-user-doc --><!-- end-user-doc -->
	 * @param value the new value of the '<em>Embedded Key</em>' attribute.
	 * @see EclipseSpeedo.metadata.JDOBoolean
	 * @see #getEmbeddedKey()
	 * @generated
	 */
	void setEmbeddedKey(JDOBoolean value);

	/**
	 * Returns the value of the '<em><b>Value Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Value Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Value Type</em>' attribute.
	 * @see #setValueType(String)
	 * @see EclipseSpeedo.metadata.MetadataPackage#getJDOMap_ValueType()
	 * @model 
	 * @generated
	 */
	String getValueType();

	/**
	 * Sets the value of the '{@link EclipseSpeedo.metadata.JDOMap#getValueType <em>Value Type</em>}' attribute.
	 * <!-- begin-user-doc --><!-- end-user-doc -->
	 * @param value the new value of the '<em>Value Type</em>' attribute.
	 * @see #getValueType()
	 * @generated
	 */
	void setValueType(String value);

	/**
	 * Returns the value of the '<em><b>Embedded Value</b></em>' attribute.
	 * The literals are from the enumeration {@link EclipseSpeedo.metadata.JDOBoolean}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Embedded Value</em>' attribute isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Embedded Value</em>' attribute.
	 * @see EclipseSpeedo.metadata.JDOBoolean
	 * @see #setEmbeddedValue(JDOBoolean)
	 * @see EclipseSpeedo.metadata.MetadataPackage#getJDOMap_EmbeddedValue()
	 * @model 
	 * @generated
	 */
	JDOBoolean getEmbeddedValue();

	/**
	 * Sets the value of the '{@link EclipseSpeedo.metadata.JDOMap#getEmbeddedValue <em>Embedded Value</em>}' attribute.
	 * <!-- begin-user-doc --><!-- end-user-doc -->
	 * @param value the new value of the '<em>Embedded Value</em>' attribute.
	 * @see EclipseSpeedo.metadata.JDOBoolean
	 * @see #getEmbeddedValue()
	 * @generated
	 */
	void setEmbeddedValue(JDOBoolean value);

	/**
	 * Returns the value of the '<em><b>Extensions</b></em>' containment reference list.
	 * The list contents are of type {@link EclipseSpeedo.metadata.JDOExtension}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Extensions</em>' containment reference
	 * list isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Extensions</em>' containment reference list.
	 * @see EclipseSpeedo.metadata.MetadataPackage#getJDOMap_Extensions()
	 * @model type="EclipseSpeedo.metadata.JDOExtension" containment="true"
	 * @generated
	 */
	EList getExtensions();

} // JDOMap
