/*
 * Created on Nov 4, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package org.objectweb.eclipsespeedo.metadata.jdt.initializers;

import org.eclipse.jdt.core.IField;
import org.eclipse.jdt.core.IJavaProject;
import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.core.JavaModelException;
import org.eclipse.jdt.core.Signature;

import org.objectweb.eclipsespeedo.metadata.JDOField;
import org.objectweb.eclipsespeedo.metadata.MetadataFactory;
import org.objectweb.eclipsespeedo.metadata.initializers.JDOFieldInitializer;

/**
 * @author yyang
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class FieldInitializer implements JDOFieldInitializer
{
	/* (non-Javadoc)
	 * @see EclipseSpeedo.metadata.initializers.JDOFieldInitializer#initialize(EclipseSpeedo.metadata.JDOField, java.lang.Object)
	 */
	public void initialize(JDOField jdoField, Object context)
	{
		IField field = (IField) context;
		IJavaProject javaProject = field.getJavaProject();
		IType type = (IType) field.getParent();
		try
		{
			String signature = field.getTypeSignature();
			int count = Signature.getArrayCount(signature);
			if (count != 0)
			{
				jdoField.setArray(MetadataFactory.eINSTANCE.createJDOArray());
				return;
			}
			String typeName = Signature.toString(signature);
			String [][] arrays = type.resolveType(typeName);
			if (arrays == null || arrays.length == 0)
			{
				return;
			}
			String qualifierName = arrays[0][0] + "." + arrays[0][1];
						
			IType javaType = javaProject.findType(qualifierName);
			if (javaType != null)
			{
				if (isSubTypeOf(javaType, "java.util.Collection"))
				{
					jdoField.setCollection(
						MetadataFactory.eINSTANCE.createJDOCollection());
					return;
				}
				if (isSubTypeOf(javaType, "java.util.Map"))
				{
					jdoField.setMap(MetadataFactory.eINSTANCE.createJDOMap());
					return;
				}
			}
		}
		catch (JavaModelException e)
		{
		}
	}

	static private boolean isSubTypeOf(IType type, String typeName)
	{
		String name = type.getFullyQualifiedName('.');
		if (name.equals(typeName))
		{
			return true;
		}
		try
		{
			String[] superInterfaceNames = type.getSuperInterfaceNames();
			for (int i = 0; i < superInterfaceNames.length; i++)
			{
				String[][] arrays = type.resolveType(superInterfaceNames[i]);
				if (arrays != null && arrays.length > 0)
				{
					String qualifierName = arrays[0][0] + "." + arrays[0][1];
					IType superType =
						type.getJavaProject().findType(qualifierName);
					if (superType != null && isSubTypeOf(superType, typeName))
					{
						return true;
					}
				}
			}
		}
		catch (JavaModelException e)
		{
		}

		return false;
	}
}
