/*******************************************************************************
 * EclipseJDO: Plugin for JDO drivers within Eclipse platform
 * Copyright (c) 2002, 2003 Versant France http://www.versant.fr
 * 
 * This program is free software; you can redistribute it and/or modify  it 
 * under the terms of the GNU General Public License as published by  the Free 
 * Software Foundation; either version 2 of the License, or  (at your option) any 
 * later version. 

 * This program is distributed in the hope that it will be useful,  but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE.  See the  GNU General Public License for more details. 

 * You should have received a copy of the GNU General Public License along with 
 * this program; if not, write to the Free Software  Foundation, Inc., 59 Temple 
 * Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contributors:
 * 	 Versant France
 * 		Yves Yang (yang@versant.fr)
 * 
 * 	 DESS GLA - University Paris 6
 * 		- initial project
 * 		  Xiao-Ta HUANG (xthuang@dess-gla.infop6.jussieu.fr)
 * 		  Guillaume BOUICHET (gbuichet@dess-gla.infop6.jussieu.fr)  
 *******************************************************************************/

package org.objectweb.eclipsespeedo.ui;

import java.io.ByteArrayInputStream;
import java.io.InputStream;

import org.eclipse.core.resources.IStorage;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IPath;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.IPersistableElement;
import org.eclipse.ui.IStorageEditorInput;

/**
 * @author yyang
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
class MemoryEditorInput implements IStorageEditorInput
{
	String content;
	/**
	 * 
	 */
	public MemoryEditorInput(String content)
	{
		this.content = content;
	}

	public class MemoryStorage implements IStorage
	{
		/**
		 * @see IStorage#getContents()
		 */
		public InputStream getContents() throws CoreException
		{
			return new ByteArrayInputStream(content.getBytes());
		}

		/**
		 * @see IStorage#getFullPath()
		 */
		public IPath getFullPath()
		{
			return null;
		}

		/**
		 * @see IStorage#getName()
		 */
		public String getName()
		{
			return "Empty";
		}

		/**
		 * @see IStorage#isReadOnly()
		 */
		public boolean isReadOnly()
		{
			return true;
		}

		/**
		 * @see IAdaptable#getAdapter(Class)
		 */
		public Object getAdapter(Class adapter)
		{
			return null;
		}

	}
	/**
	 * @see IStorageEditorInput#getStorage()
	 */
	public IStorage getStorage() throws CoreException
	{
		return new MemoryStorage();
	}

	/**
	 * @see IEditorInput#exists()
	 */
	public boolean exists()
	{
		return false;
	}

	/**
	 * @see IEditorInput#getImageDescriptor()
	 */
	public ImageDescriptor getImageDescriptor()
	{
		return null;
	}

	/**
	 * @see IEditorInput#getName()
	 */
	public String getName()
	{
		return "Null EditorInput";
	}

	/**
	 * @see IEditorInput#getPersistable()
	 */
	public IPersistableElement getPersistable()
	{
		return null;
	}

	/**
	 * @see IEditorInput#getToolTipText()
	 */
	public String getToolTipText()
	{
		return null;
	}

	/**
	 * @see IAdaptable#getAdapter(Class)
	 */
	public Object getAdapter(Class adapter)
	{
		return null;
	}

}
