package org.objectweb.eclipsespeedo.ui.metadataeditor;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.Properties;
import java.util.StringTokenizer;

import org.eclipse.core.runtime.Path;

import org.objectweb.eclipsespeedo.EclipseSpeedoPlugin;


public class VendorExtensionProperties {

	private static VendorExtensionProperties v = new VendorExtensionProperties();
	private static Properties prop;

	public VendorExtensionProperties() {
		prop = new Properties();
		try	{
			prop.load(EclipseSpeedoPlugin.getDefault().openStream(new Path("jdoextension.properties")));
		}
		catch (Exception e)	{
			e.printStackTrace();
		}
	}

	public static Collection getVendor() {

		Collection result = new ArrayList();
		String toToken = prop.getProperty("vendors");
		if (toToken == null) return null;
		StringTokenizer st = new StringTokenizer(toToken, ";");

		while (st.hasMoreTokens())	{
			result.add(st.nextToken().trim());
		}
		return result;
	}

	public static String[] getVendorArray()	{

		Collection result = new ArrayList();
		String toToken = prop.getProperty("vendors");
		if (toToken == null) return null;
		StringTokenizer st = new StringTokenizer(toToken, ";");

		while (st.hasMoreTokens())	{
			result.add(st.nextToken().trim());
		}
		String[] res = new String[result.size()];

		Iterator it = result.iterator();
		int i = 0;
		while (it.hasNext()) {
			res[i] = (String) it.next();
			i++;
		}
		return res;
	}

	public static Collection getkeys(String vendor)	{
		Collection result = new ArrayList();

		String toToken = prop.getProperty("vendors." + formatText(vendor) + ".keys");
		if (toToken == null) return null;
		StringTokenizer st = new StringTokenizer(toToken, ";");
		while (st.hasMoreTokens())	{
			result.add(st.nextToken().trim());
		}

		return result;
	}

	public static String[] getKeysArray(String vendor) {
		Collection result = new ArrayList();
		String toToken; 
		try {
			toToken = prop.getProperty("vendors." + formatText(vendor) + ".keys");
		}
		catch (Exception e) {
			e.printStackTrace(); 
			toToken = null;
		}
		if (toToken == null) return null;
		StringTokenizer st = new StringTokenizer(toToken, ";");
		while (st.hasMoreTokens()) {
			result.add(st.nextToken().trim());
		}

		String[] res = new String[result.size()];

		Iterator it = result.iterator();
		int i = 0;
		while (it.hasNext()) {
			res[i] = (String) it.next();
			i++;
		}

		return res;
	}

	public static Collection getValues(String vendor, String key) {
		Collection result = new ArrayList();

		String toToken = prop.getProperty("vendors."+ formatText(vendor)+ ".keys."+ formatText(key)+ ".values");
		if (toToken == null) return null;
		StringTokenizer st = new StringTokenizer(toToken, ";");
		while (st.hasMoreTokens())	{
			result.add(st.nextToken().trim());
		}

		return result;
	}

	public static String[] getValuesArray(String vendor, String key) {
		Collection result = new ArrayList();

		String toToken = prop.getProperty("vendors."+ formatText(vendor)+ ".keys."+ formatText(key)+ ".values");
		if (toToken == null) return null;
		StringTokenizer st = new StringTokenizer(toToken, ";");
		while (st.hasMoreTokens()) {
			result.add(st.nextToken().trim());
		}

		String[] res = new String[result.size()];

		Iterator it = result.iterator();
		int i = 0;
		while (it.hasNext()) {
			res[i] = (String) it.next();
			i++;
		}

		return res;
	}

	private static String formatText(String txt) {
		StringTokenizer st = new StringTokenizer(txt, " ");
		String result;
		if (st.hasMoreTokens()) result = st.nextToken();
		else return "";
		while (st.hasMoreTokens()) {
			result += "_" + st.nextToken();
		}
		return result;
	}
}
