/*******************************************************************************
 * EclipseJDO: Plugin for JDO drivers within Eclipse platform
 * Copyright (c) 2002, 2003 Versant France http://www.versant.fr
 * 
 * This program is free software; you can redistribute it and/or modify  it 
 * under the terms of the GNU General Public License as published by  the Free 
 * Software Foundation; either version 2 of the License, or  (at your option) any 
 * later version. 

 * This program is distributed in the hope that it will be useful,  but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE.  See the  GNU General Public License for more details. 

 * You should have received a copy of the GNU General Public License along with 
 * this program; if not, write to the Free Software  Foundation, Inc., 59 Temple 
 * Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contributors:
 * 	 Versant France
 * 		Yves Yang (yang@versant.fr)
 * 
 * 	 DESS GLA - University Paris 6
 * 		- initial project
 * 		  Xiao-Ta HUANG (xthuang@dess-gla.infop6.jussieu.fr)
 * 		  Guillaume BOUICHET (gbuichet@dess-gla.infop6.jussieu.fr)  
 *******************************************************************************/

package org.objectweb.eclipsespeedo.wizards;

import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jdt.core.IJavaProject;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.jface.wizard.Wizard;

import org.objectweb.eclipsespeedo.EclipseSpeedoPlugin;
import org.objectweb.eclipsespeedo.actions.MainCreation;


/**
 * Main class of the main creation wizard Allow to choose the java file , and
 * to create jdo properties configuration. It also add the necessary imports
 * and the JDO classpath entry
 */
public class MainCreationWizard extends Wizard
{
	private IJavaElement jEl;
	private IJavaProject jp;
	private IPreferenceStore st;
	private MainCreation mainCreation;

	/**
	 * Constructor. Setup the java project
	 * 
	 * @param projectName
	 */

	public MainCreationWizard(IJavaElement jEl)	{
		super();
		this.jEl = jEl;
		jp = this.jEl.getJavaProject();
		st = EclipseSpeedoPlugin.getDefault().getPreferenceStore();
	}

	private MainCreationWizardPage page;

	public void addPages() {
		page = new MainCreationWizardPage(this.jEl);
		addPage(page);
		this.mainCreation = new MainCreation(page, jp.getProject());
	}


	public boolean performFinish() {
		return mainCreation.doChange();
	}
}
