/*******************************************************************************
 * EclipseJDO: Plugin for JDO drivers within Eclipse platform
 * Copyright (c) 2002, 2003 Versant France http://www.versant.fr
 * 
 * This program is free software; you can redistribute it and/or modify  it 
 * under the terms of the GNU General Public License as published by  the Free 
 * Software Foundation; either version 2 of the License, or  (at your option) any 
 * later version. 

 * This program is distributed in the hope that it will be useful,  but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE.  See the  GNU General Public License for more details. 

 * You should have received a copy of the GNU General Public License along with 
 * this program; if not, write to the Free Software  Foundation, Inc., 59 Temple 
 * Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contributors:
 * 	 Versant France
 * 		Yves Yang (yang@versant.fr)
 * 
 *******************************************************************************/

package org.objectweb.eclipsespeedo.xml.resource;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.xmi.XMLHelper;
import org.eclipse.emf.ecore.xmi.XMLLoad;
import org.eclipse.emf.ecore.xmi.XMLResource;
import org.eclipse.emf.ecore.xmi.XMLSave;
import org.eclipse.emf.ecore.xmi.impl.XMLMapImpl;
import org.eclipse.emf.ecore.xmi.impl.XMLResourceImpl;

import org.objectweb.eclipsespeedo.metadata.MetadataPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>XML Resource</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 */
public class DTDXMLResourceImpl extends XMLResourceImpl {
	static XMLMap xmlMap = null;

	static XMLMap getMetadataMap() {
		if (xmlMap == null) {
			xmlMap = new XMLMapImpl();

			xmlMap.setNoNamespacePackage(MetadataPackage.eINSTANCE);
		}
		return xmlMap;
	}

	/**
	 */
	protected DTDXMLResourceImpl() {
		super();
	}

	/**
	 * Constructor for XMLResourceImpl.
	 * @param uri
	 */
	public DTDXMLResourceImpl(URI uri) {
		super(uri);

		getDefaultSaveOptions().put(
			XMLResource.OPTION_XML_MAP,
			getMetadataMap());
		getDefaultLoadOptions().put(
			XMLResource.OPTION_XML_MAP,
			getMetadataMap());
	}

	protected XMLLoad createXMLLoad() {
		XMLHelper helper = createXMLHelper();
		helper.setNoNamespacePackage(MetadataPackage.eINSTANCE);
		return new DTDXMLLoadImpl(helper);
	}

	protected XMLSave createXMLSave() {
		XMLHelper helper = createXMLHelper();
		helper.setNoNamespacePackage(MetadataPackage.eINSTANCE);
		return new DTDXMLSaveImpl(helper);
	}
} //XMLResourceImpl
