/*******************************************************************************
 * EclipseJDO: Plugin for JDO drivers within Eclipse platform
 * Copyright (c) 2002, 2003 Versant France http://www.versant.fr
 * 
 * This program is free software; you can redistribute it and/or modify  it 
 * under the terms of the GNU General Public License as published by  the Free 
 * Software Foundation; either version 2 of the License, or  (at your option) any 
 * later version. 

 * This program is distributed in the hope that it will be useful,  but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE.  See the  GNU General Public License for more details. 

 * You should have received a copy of the GNU General Public License along with 
 * this program; if not, write to the Free Software  Foundation, Inc., 59 Temple 
 * Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contributors:
 * 	 Versant France
 * 		Yves Yang (yang@versant.fr)
 * 
 *******************************************************************************/
package org.objectweb.eclipsespeedo.xml.resource;

import java.util.List;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.xmi.XMLHelper;
import org.eclipse.emf.ecore.xmi.XMLResource;
import org.eclipse.emf.ecore.xmi.impl.XMLSaveImpl;

import org.objectweb.eclipsespeedo.project.EclipseSpeedoProjectHelper;

/**
 * @author yyang
 * 
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class DTDXMLSaveImpl extends XMLSaveImpl
{
	/**
	 * @param helper
	 */
	public DTDXMLSaveImpl(XMLHelper helper)
	{
		super(helper);
	}

	public void traverse(List contents)
	{
		if (declareXML)
		{
			XMLResource resource = helper.getResource();
			String metaDataDocType =
				EclipseSpeedoProjectHelper.findMetadataDocType();

			doc.add(
				"<?xml version=\""
					+ XML_VERSION
					+ "\" encoding=\""
					+ encoding
					+ "\"?>");
			doc.addLine();
			if (metaDataDocType != null && metaDataDocType.length() > 0)
			{
				doc.add("<!DOCTYPE jdo " + metaDataDocType + ">");
				doc.addLine();
			}
		}

		int size = contents.size();

		// Reserve a place to insert xmlns declarations after we know what they
		// all are.
		//
		Object mark;

		if (size == 1)
		{
			mark = writeTopObject((EObject) contents.get(0));
		}
		else
		{
			mark = writeTopObjects(contents);
		}

		// Go back and add all the XMLNS stuff.
		//
		doc.resetToMark(mark);
		addNamespaceDeclarations();
	}
}
