/*******************************************************************************
 * EclipseJDO: Plugin for JDO drivers within Eclipse platform
 * Copyright (c) 2002, 2003 Versant France http://www.versant.fr
 * 
 * This program is free software; you can redistribute it and/or modify  it 
 * under the terms of the GNU General Public License as published by  the Free 
 * Software Foundation; either version 2 of the License, or  (at your option) any 
 * later version. 

 * This program is distributed in the hope that it will be useful,  but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE.  See the  GNU General Public License for more details. 

 * You should have received a copy of the GNU General Public License along with 
 * this program; if not, write to the Free Software  Foundation, Inc., 59 Temple 
 * Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contributors:
 * 	 Versant France
 * 		Yves Yang (yang@versant.fr)
 * 
 * 	 DESS GLA - University Paris 6
 * 		- initial project
 * 		  Xiao-Ta HUANG (xthuang@dess-gla.infop6.jussieu.fr)
 * 		  Guillaume BOUICHET (gbuichet@dess-gla.infop6.jussieu.fr)  
 *******************************************************************************/

package org.objectweb.eclipsespeedo.xml.resource;

//eclipse import

import java.io.InputStreamReader;

import org.xml.sax.EntityResolver;
import org.xml.sax.InputSource;

/**
 * This class is used to find the rigth jdo dtd
 * It implies that the jdo.jar is included in the plugin classpath
 */
public class JDOResolver implements EntityResolver {
	public InputSource resolveEntity(String publicId, String systemId) {
		if (systemId.endsWith("jdo.dtd")) {
			// the jdo.dtd file is in jdo.jar at javax/jdo/jdo.dtd
			java.io.InputStream inputstream =
				getClass().getClassLoader().getResourceAsStream(
					"javax/jdo/jdo.dtd");
			if (inputstream != null)
				return new InputSource(new InputStreamReader(inputstream));
		}
		//if we don't find it we return null;
		return null;
	}
}
