/**
 * copyright area
 */
package org.objectweb.speedo.metadata;

import java.util.Iterator;
import java.util.Map;

/**
 * @author S.Chassande-Barrioz
 */
public class SpeedoMetaInfo {

	/**
	 * This fields is used by the Speedo to reference the SpeedoXMLDescriptor.
	 * This field is filled by the JDOParser.
	 * key = jdo File Name
	 * value = SpeedoXMLDescriptor
	 */
	public Map xmldescriptor = null;


	public SpeedoClass getSpeedoClass(String className) {
		return getSpeedoClass(className, (SpeedoXMLDescriptor) null);
	}

	public SpeedoClass getSpeedoClass(String className, SpeedoXMLDescriptor xml) {
		//System.out.println("SMI.getSpeedoClass(" + className + ", " + xml.xmlFile + "): ");
		SpeedoClass sc = null;
		if (xml != null) {
			sc = xml.getSpeedoClass(className, false);
			if (sc != null) {
				//System.out.println("SMI.getSpeedoClass(XML): return " + sc);
				return sc;
			}
		}
		//Try in other xml
		for(Iterator it = xmldescriptor.values().iterator();
		    it.hasNext() && sc == null;) {
			SpeedoXMLDescriptor _xml = (SpeedoXMLDescriptor) it.next();
			if (xml == _xml) {
				continue;
			}
			sc = _xml.getSpeedoClass(className, false);
		}
		//System.out.println("SMI.getSpeedoClass(): return " + sc);
		return sc;
	}

	public SpeedoClass getSpeedoClass(String className, SpeedoPackage sp) {
		//System.out.println("SMI.getSpeedoClass(" + className + ", " + sp.name + "): ");
		SpeedoXMLDescriptor xml = null;
		if (sp != null) {
			xml = sp.jdoXMLDescriptor;
		}
		SpeedoClass sc = getSpeedoClass(className, xml);
		if (sc == null) {
			sc = getSpeedoClass(sp.name + '.' + className, xml);
		}
		//System.out.println("SMI.getSpeedoClass(P): return " + sc);
		return sc;
	}

}
