/**
 * copyright area
 */
package org.objectweb.speedo.query.api;

import org.objectweb.medor.api.MedorException;
import org.objectweb.medor.expression.api.ExpressionException;
import org.objectweb.speedo.api.SpeedoException;
import org.objectweb.speedo.pm.api.ProxyManager;

import java.util.Collection;
import java.util.Map;

/**
 * @author S.Chassande-Barrioz
 */
public interface CompiledQuery {

    short UNDEFINED = 0;
    short DEFINED = 1;
    short COMPILED = 2;

    void compile() throws SpeedoException, MedorException, ExpressionException;

    Collection execute(Object[] parameters, ProxyManager pm)
            throws SpeedoException, MedorException, ExpressionException;

    Collection execute(Map parameters, ProxyManager  pm)
            throws SpeedoException, MedorException, ExpressionException;

    short getStatus();
}
